#include <plib.h>
#include <p32xxxx.h>

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency			60000000L
#define CoreTick				( SystemFrequency / 2 / CoreTogglesPerSec )
#define CoreTogglesPerSec		2
#define PBFrequency				SystemFrequency / 1
#define Timer1Tick				( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec		10

// To Do : إCore Timer_AȨ禡AëwDn_uv3C
void __ISR( _CORE_TIMER_VECTOR , ipl3 ) ISR_CoreTimer( void )
{
	// To Do : MCore Timer_XСC
    mCTClearIntFlag();
    
	// To Do : sCore TimerPeriodC
	UpdateCoreTimer( CoreTick );
    
	// LEDAϦVC
	mPORTAToggleBits( BIT_0 );
}

// To Do : إTimer1_AȨ禡AëwDn_uv4C
void __ISR(_TIMER_1_VECTOR, ipl4 ) ISR_Imier1( void )
{	
	static unsigned i = 0;

	// To Do : MTimer_XСC
	mT1ClearIntFlag( );

	// ݨDgWLPRxpƽd(65,535), TimerxLkTB@,
	// ]ftnޥqӳBz, FgݨDC 
	if( ++i > 9 )
	{
		i = 0;

		// LEDAϦVC
		mPORTAToggleBits( BIT_1 );
	}
}

int main(void)
{
	// Disable the JTAG function
	DDPCONbits.JTAGEN = 0;  				

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

	// ϥC32 Interrupt Function]wh_VqҦC
    INTEnableSystemMultiVectoredInt( );

	// ϥC32 I/O Prot FunctionNLEDI/O ]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
	mPORTAClearBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// To Do : ϥC32 Core Timer FunctionҥCore TimerAëwDn_uv3C
 	mConfigIntCoreTimer( CT_INT_ON | CT_INT_PRIOR_3 );

	// To Do : ϥC32 Core Timer Functioni]wC
	OpenCoreTimer( CoreTick );

	// To Do : ϥC32 Timer FunctionҥTimerAëwDn_uv4C
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// To Do : ϥC32 Timer Functioni]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

    while( 1 );
}
