#include <plib.h>
#include <p32xxxx.h>
#include "LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency			60000000L
#define CoreTick				( SystemFrequency / 2 / CoreTogglesPerSec )
#define CoreTogglesPerSec		2
#define PBFrequency				SystemFrequency / 1
#define Timer1Tick				( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec		10

const unsigned char LCMString1[ ] = "PIC32MX795F512L "; 
const unsigned char LCMString2[ ] = "Countting:      "; 
volatile unsigned char Timer1TickFlag = 0;

// إCore Timer_AȨ禡AëwDn_uv3C
void __ISR( _CORE_TIMER_VECTOR , ipl3 ) ISR_CoreTimer( void )
{
	// MCore Timer_XСC
    mCTClearIntFlag();
    
	// sCore TimerPeriodC
	UpdateCoreTimer( CoreTick );
    
	// LEDAϦVC
	mPORTAToggleBits( BIT_0 );
}

// إTimer1_AȨ禡AëwDn_uv4C
void __ISR(_TIMER_1_VECTOR, ipl4 ) ISR_Imier1( void )
{	
	static unsigned i = 0;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// ݨDgWLPRxpƽd(65,535), TimerxLkTB@,
	// ]ftnޥqӳBz, FgݨDC 
	if( ++i > 9 )
	{
		i = 0;

		// LEDAϦVC
		mPORTAToggleBits( BIT_1 );
	}

	Timer1TickFlag++;
}

int main(void)
{
	// Disable the JTAG function
	DDPCONbits.JTAGEN = 0;  				

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

	// ϥC32 Interrupt Function]wh_VqҦC
    INTEnableSystemMultiVectoredInt( );

	// ϥC32 I/O Prot FunctionNLEDI/O ]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
	mPORTAClearBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ϥC32 Core Timer FunctionҥCore TimerAëwDn_uv3C
 	mConfigIntCoreTimer( CT_INT_ON | CT_INT_PRIOR_3 );

	// ϥC32 Core Timer Functioni]wC
	OpenCoreTimer( CoreTick );

	// ϥC32 Timer FunctionҥTimerAëwDn_uv4C
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// ϥC32 Timer Functioni]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// To Do : ϥC32 PMP Function]wPMP ModuleC
	mPMPOpen( PMP_ON | PMP_IDLE_CON | PMP_MUX_OFF | PMP_TTL | PMP_READ_WRITE_EN |
			  PMP_CS2_CS1_OFF | PMP_LATCH_POL_LO | PMP_CS1_POL_LO | PMP_CS2_POL_LO |
			  PMP_WRITE_POL_HI | PMP_READ_POL_HI ,
			  PMP_IRQ_READ_WRITE | PMP_AUTO_ADDR_OFF | PMP_DATA_BUS_8 | PMP_MODE_MASTER1 |
			  PMP_WAIT_BEG_4 | PMP_WAIT_MID_15 | PMP_WAIT_END_4 ,
			  PMP_PEN_0 , 
			  PMP_INT_OFF | PMP_INT_PRI_0 );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	while( 1 )
	{ 
		if( Timer1TickFlag )
		{
			static unsigned int Counter = 0;

			Timer1TickFlag--;

			// ]wCСAXƦrC
			LCM_SetCursor( 11 , 1 );
			LCM_PutNumber( Counter++ , 4 );
		}
	}

    while( 1 );
}
