#include <plib.h>
#include <p32xxxx.h>
#include "App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency			60000000L
#define CoreTick				( SystemFrequency / 2 / CoreTogglesPerSec )
#define CoreTogglesPerSec		2
#define PBFrequency				SystemFrequency / 1
#define Timer1Tick				( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec		20

const unsigned char LCMString1[ ] = "PIC32MX795F512L "; 
const unsigned char LCMString2[ ] = "VR1:    ,VR2:   "; 
unsigned int VR1Value = 0;
unsigned int VR2Value = 0;

// إCore Timer_AȨ禡AëwDn_uv3C
void __ISR( _CORE_TIMER_VECTOR , ipl3 ) ISR_CoreTimer( void )
{
	// MCore Timer_XСC
    mCTClearIntFlag();
    
	// sCore TimerPeriodC
	UpdateCoreTimer( CoreTick );
    
	// LEDAϦVC
	mPORTAToggleBits( BIT_0 );
}

// إTimer1_AȨ禡AëwDn_uv4C
void __ISR(_TIMER_1_VECTOR, ipl4 ) ISR_Imier1( void )
{	
	static unsigned i = 0;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// ϥC32 ADC FunctionҰADCഫC
	ConvertADC10( );

	// ݨDgWLPRxpƽd(65,535), TimerxLkTB@,
	// ]ftnޥqӳBz, FgݨDC 
	if( ++i > 19 )
	{
		i = 0;

		// LEDAϦVC
		mPORTAToggleBits( BIT_1 );
	}
}

int main(void)
{
	// Disable the JTAG function
	DDPCONbits.JTAGEN = 0;  				

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

	// ϥC32 Interrupt Function]wh_VqҦC
    INTEnableSystemMultiVectoredInt( );

	// ϥC32 I/O Prot FunctionNLEDI/O ]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
	mPORTAClearBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ϥC32 Core Timer FunctionҥCore TimerAëwDn_uv3C
 	mConfigIntCoreTimer( CT_INT_ON | CT_INT_PRIOR_3 );

	// ϥC32 Core Timer Functioni]wC
	OpenCoreTimer( CoreTick );

	// ϥC32 Timer FunctionҥTimerAëwDn_uv4C
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// ϥC32 Timer Functioni]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// To Do : ϥC32 ADC10 Function]wADCC
	OpenADC10( ADC_MODULE_ON | ADC_IDLE_CONTINUE | ADC_FORMAT_INTG16 | ADC_CLK_MANUAL | ADC_AUTO_SAMPLING_ON | ADC_SAMP_OFF ,
			   ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_???? | ADC_SAMPLES_PER_INT_???? | ADC_ALT_BUF_OFF | ADC_ALT_INPUT_OFF ,
			   ADC_SAMPLE_TIME_31 | ADC_CONV_CLK_SYSTEM | ADC_CONV_CLK_32Tcy ,
			   ENABLE_????_ANA | ENABLE_????_ANA , 
			   SKIP_SCAN_AN0 | SKIP_SCAN_AN1 | ???? | ???? | ...);

	// To Do : ϥC32 I/O Port FunctionNTADqD]wJC
	PORTSetPinsAnalogIn( IOPORT_B , ???? | ???? );

    INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{ 
		// ഫ ?
		if( INTGetFlag( INT_AD1 ) )
		{
			// To Do : ϥC32 ADC10 FunctionŪADCഫƭȡC
			VR1Value = ( unsigned int ) ReadADC10( ???? );
			VR2Value = ( unsigned int ) ReadADC10( ???? );

			// MADC_X
			INTClearFlag( INT_AD1 );

			// ]wCСAXADCƭȡC
			LCM_SetCursor( 4 , 1 );
			LCM_PutNumber( VR1Value , 4 );
			LCM_SetCursor( 13 , 1 );
			LCM_PutNumber( VR2Value >> 1 , 3 );
		}
	}

    while( 1 );
}
