#include <plib.h>
#include <p32xxxx.h>
#include "App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency			60000000L
#define CoreTick				( SystemFrequency / 2 / CoreTogglesPerSec )
#define CoreTogglesPerSec		2
#define PBFrequency				SystemFrequency / 1
#define Timer1Tick				( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec		10

void UART_PutROMString( unsigned char * String );

const unsigned char LCMString1[ ] = "PIC32MX795F512L "; 
const unsigned char LCMString2[ ] = "Rx:             "; 
volatile unsigned char Timer1TickFlag = 0;
volatile unsigned char UART_IsReceived = 0;
volatile unsigned char UART_ReceiveBuffer = 0;
unsigned char UARTString1[ 32 ]; 
unsigned char Hours = 0 , Mins = 0 , Secs = 0;

#define UARTChannel UART2	/* UART2 for APP1632 */ 

// إCore Timer_AȨ禡AëwDn_uv3C
void __ISR( _CORE_TIMER_VECTOR , ipl3 ) ISR_CoreTimer( void )
{
	// MCore Timer_XСC
    mCTClearIntFlag();
    
	// sCore TimerPeriodC
	UpdateCoreTimer( CoreTick );
    
	// LEDAϦVC
	mPORTAToggleBits( BIT_0 );
}

// إTimer1_AȨ禡AëwDn_uv4C
void __ISR(_TIMER_1_VECTOR, ipl4 ) ISR_Imier1( void )
{	
	static unsigned i = 0;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// ݨDgWLPRxpƽd(65,535), TimerxLkTB@,
	// ]ftnޥqӳBz, FgݨDC 
	if( ++i > 9 )
	{
		i = 0;

		// LEDAϦVC
		mPORTAToggleBits( BIT_1 );

		Timer1TickFlag++;
	}
}

void __ISR( _UART_2_VECTOR , ipl5 ) ISR_UART2( void )
{
	// ϥC32 UART FunctionŪ쪺ơC
	// `N : Bƶ²ϥγ@ܼxsAYyqjɡA
	//        zLLnUAHKƿ򥢡A
	//        Ҧp:إߤ@Data QueueӦs񦬨쪺ơC
	UART_ReceiveBuffer = UARTGetDataByte( UARTChannel );

	UART_IsReceived = 1;

	// MUART _XСC
	INTClearFlag( INT_U2RX );
}

int main(void)
{
	unsigned char Cursor = 0;

	// Disable the JTAG function
	DDPCONbits.JTAGEN = 0;  				

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

	// ϥC32 Interrupt Function]wh_VqҦC
    INTEnableSystemMultiVectoredInt( );

	// ϥC32 I/O Prot FunctionNLEDI/O ]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
	mPORTAClearBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ϥC32 Core Timer FunctionҥCore TimerAëwDn_uv3C
 	mConfigIntCoreTimer( CT_INT_ON | CT_INT_PRIOR_3 );

	// ϥC32 Core Timer Functioni]wC
	OpenCoreTimer( CoreTick );

	// ϥC32 Timer FunctionҥTimerAëwDn_uv4C
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// ϥC32 Timer Functioni]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// ϥC32 UART FunctionlUARTC
	// Ref. \C32_Doc\pic32-lib-help\UART-PLIB-Help.chm
		// void UARTConfigure( UART_MODULE id , UART_CONFIGURATION flags );
		// void UARTSetFifoMode( UART_MODULE id , UART_FIFO_MODE mode );
		// void UARTSetLineControl( UART_MODULE id , UART_LINE_CONTROL_MODE mode );
		// UINT32 UARTSetDataRate( UART_MODULE id ,UINT32 sourceClock ,UINT32 dataRate );
		// void UARTEnable( UART_MODULE id , UART_ENABLE_MODE mode );

  	// MPLAB C32 1.11BP1.11A UART enum Label 
		// 1.11B				// 1.11A
		// #define UART2		UART3A
		// #define UART3		UART2A
		// #define UART4		UART1B
		// #define UART5		UART3B
		// #define UART6		UART2B
		// UART1 P UART1A wbHeader Filewq, (Ex: Ref. p32mx795f512l.h )

	UARTConfigure( UARTChannel , UART_ENABLE_PINS_TX_RX_ONLY );
	UARTSetFifoMode( UARTChannel , UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY );
	UARTSetLineControl( UARTChannel , UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1 ); 
	UARTSetDataRate( UARTChannel , PBFrequency , 9600 );
	UARTEnable( UARTChannel , UART_ENABLE | UART_PERIPHERAL | UART_TX | UART_RX ); 

	// ϥC32 UART FunctionҥUARTAëw䤤_uvC
		// Ref. \C32_Doc\pic32-lib-help\INT-PLIB-Help.chm
		// void INTSetVectorPriority( INT_VECTOR vector , INT_PRIORITY priority );
		// void INTSetVectorSubPriority( INT_VECTOR vector , INT_SUB_PRIORITY subPriority );
		// void INTEnable( INT_SOURCE source , INT_EN_DIS enable );

  	// MPLAB C32 1.11BP1.11A UART INT Label 
		// 1.11B							// 1.11A
		// #define INT_UART_1_VECTOR		INT_UART_1A_VECTOR
		// #define INT_UART_2_VECTOR		INT_UART_3A_VECTOR
		// #define INT_UART_4_VECTOR		INT_UART_1B_VECTOR
		// #define INT_UART_3_VECTOR		INT_UART_2A_VECTOR
		// #define INT_UART_6_VECTOR		INT_UART_2B_VECTOR
		// #define INT_UART_5_VECTOR		INT_UART_3B_VECTOR

	INTSetVectorPriority( INT_UART_2_VECTOR , INT_PRIORITY_LEVEL_5 );
	INTSetVectorSubPriority( INT_UART_2_VECTOR , INT_SUB_PRIORITY_LEVEL_0 );
	INTEnable( INT_U2RX , INT_ENABLED );

	Cursor = 3;

    INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{
		// UART ?
		if( UART_IsReceived )
		{
			UART_IsReceived = 0;

			// ]wCСAXrC
			LCM_SetCursor( Cursor++ , 1 );
			LCM_PutASCII( UART_ReceiveBuffer );

			if( Cursor > 15 ) Cursor = 3;
		}

		// BzC
		if( Timer1TickFlag >= 1 ) 	
		{
			if( ++Secs > 59 ) 
			{
				Secs = 0;
				if( ++Mins > 59 )
				{
					Mins = 0;
					if( ++Hours > 23 )
						Hours = 0;
				}
			}

			sprintf( UARTString1 , "Now Time %2d:%2d:%2d\r" ,
					 Hours , Mins , Secs );

 			// ϥC32 I/O UART FunctionNrzLUARTXC
			UART_PutROMString( UARTString1 );

			Timer1TickFlag--;
		}
	}

	while( 1 );
}

void UART_PutROMString( unsigned char * String ) 
{
	while ( *String != 0x00 )
	{
		while( !UARTTransmitterIsReady( UARTChannel ) );
	    UARTSendDataByte( UARTChannel , *String++ );
	}
}
